#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <osreldate.h>
#include <pthread.h>
#include <pthread_np.h>

MODULE = Pthread::GetThreadId PACKAGE = Pthread::GetThreadId

long getthreadid_np()
  CODE:
#if __FreeBSD_version >= 900031
    RETVAL = (long) pthread_getthreadid_np();
#else
    /* dirty hack for FreeBSD 8 and earlier missing pthread_getthreadid_np() */
    RETVAL = *((long*)pthread_self());
#endif

  OUTPUT:
    RETVAL
